"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _helperPluginUtils = require("@babel/helper-plugin-utils");

var _pluginSyntaxClassStaticBlock = _interopRequireDefault(require("@babel/plugin-syntax-class-static-block"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function generateUid(scope, denyList) {
  const name = "";
  let uid;
  let i = 1;

  do {
    uid = scope._generateUid(name, i);
    i++;
  } while (denyList.has(uid));

  return uid;
}

var _default = (0, _helperPluginUtils.declare)(({
  types: t,
  template,
  assertVersion
}) => {
  assertVersion("^7.12.0");
  return {
    name: "proposal-class-static-block",
    inherits: _pluginSyntaxClassStaticBlock.default,
    visitor: {
      Class(path) {
        const {
          scope
        } = path;
        const classBody = path.get("body");
        const privateNames = new Set();
        let staticBlockPath;

        for (const path of classBody.get("body")) {
          if (path.isPrivate()) {
            privateNames.add(path.get("key.id").node.name);
          } else if (path.isStaticBlock()) {
            staticBlockPath = path;
          }
        }

        if (!staticBlockPath) {
          return;
        }

        const staticBlockRef = t.privateName(t.identifier(generateUid(scope, privateNames)));
        classBody.pushContainer("body", t.classPrivateProperty(staticBlockRef, template.expression.ast`(() => { ${staticBlockPath.node.body} })()`, [], true));
        staticBlockPath.remove();
      }

    }
  };
});

exports.default = _default;